// Engine.h -- Game engine

#define TILEWIDTH 16
#define TILEHEIGHT 16
#define MAPWIDTH 30
#define MAPHEIGHT 17

struct Character {
	int x,y;
	int dir;
	int delay;	
};
struct Game {
	char map[MAPWIDTH*MAPHEIGHT];
	int level;
	int score;
	int lives;
	int treasures;
	struct Character npc[2];
	struct Character player;
};

#define M_WALL 0
#define M_OPENPATH 1
#define M_VISITEDPATH 2
#define M_TREASURE 3
#define M_PLAYER 4
#define M_NPC 5
#define M_LEVEL 6
#define M_SCORE 9
#define M_WHITE 12

#define S_POP 0
#define S_BALLBAT 1
#define S_HIYA 2
#define S_BOMB 3
#define S_APPLAUSE 4
#define S_RUSH 5
#define S_ALONE 6

#define D_NONE -1
#define D_LEFT 0
#define D_UP 1
#define D_RIGHT 2
#define D_DOWN 3

extern struct Game game;
// Engine implemented
void new_game();
void new_level(int level);
void next_frame(int elapsed);
void draw_map();
void move_character(int direction);
void explode_path();
// SDL implemented
void draw_tile(int id,int x,int y);
void play_sound(int id);
void draw_number(int id,int x,int y);
